<template>
	<div class="q-pa-md q-gutter-sm">
		<q-dialog v-model="userAddTask" class="dialog">
			<q-card style="width: 500px;">
				<div class="row">
					<q-card-section>
						<div class="text-h6">Assign task</div>
					</q-card-section>
					<q-space />
					<q-card-section>
						<q-btn round dense icon="close" v-close-popup />
					</q-card-section>
				</div>

				<q-card-section class="q-pt-none">
					<div>Assign task for {{ userName }}</div>
					<br />
					<q-input
						outlined
						v-model="note"
						label="Note"
						type="textarea"
						:rules="[
							(val) => !!val || 'Field is required',
							(val) =>
								val.length > 2 ||
								'Please use maximum 2 character',
						]"
						ref="note"
					/>
					<div class="q-pa-md q-gutter-sm">
						<q-dialog
							v-model="alertSuccess"
							persistent
							transition-show="scale"
							transition-hide="scale"
						>
							<q-card
								class="bg-green-9 text-white"
								style="width: 300px;"
							>
								<q-card-section>
									<div class="text-h6">Success</div>
								</q-card-section>

								<q-card-section class="q-pt-none">
									Task assigned.
								</q-card-section>

								<q-card-actions
									align="right"
									class="bg-white text-teal"
								>
									<q-btn flat label="OK" v-close-popup />
								</q-card-actions>
							</q-card>
						</q-dialog>
					</div>
					<q-btn
						style="width: 100%;"
						label="Assign"
						color="primary"
						type="button"
						@click="addUserTask"
					/>
				</q-card-section>
			</q-card>
		</q-dialog>
	</div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapActions } from "vuex";
export default {
	data() {
		return {
			alertSuccess: false,
			note: null,
		};
	},
	methods: {
		addUserTask() {
			this.$refs.note.validate();
			if (!this.$refs.note.hasError) {
				this.$axios.post(this.host + "/src/php/actions/todo.php", {
					userId: this.userId,
					note: this.note,
				});
				this.alertSuccess = true;
			}
			this.$emit("reload");
		},
		// ...mapActions({
		// 	userName: "showcase/userName",
		// }),
	},
	computed: {
		...mapGetters({
			addTask: "showcase/userAddTask",
			userId: "showcase/userId",
			userName: "showcase/userName",
		}),
		userAddTask: {
			get() {
				return this.addTask;
			},
			set(val) {
				this.$store.commit("showcase/hideUserAddForm", val);
			},
		},
	},
};
</script>
